using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using DCON_PC_DOTNET;

namespace AO
{
	/// <summary>
	/// Form1 的摘要描述。
	/// </summary>
	public class form1 : System.Windows.Forms.Form
	{
		private System.Windows.Forms.TextBox textAddress;
		private System.Windows.Forms.Label label11;
		private System.Windows.Forms.TextBox textTotalChannel;
		private System.Windows.Forms.Label label6;
		private System.Windows.Forms.TextBox textTimeout;
		private System.Windows.Forms.TextBox textChecksum;
		private System.Windows.Forms.TextBox textSlot;
		private System.Windows.Forms.TextBox textBaudrate;
		private System.Windows.Forms.TextBox textComport;
		private System.Windows.Forms.Label label5;
		private System.Windows.Forms.Label label4;
		private System.Windows.Forms.Label label3;
		private System.Windows.Forms.Label label2;
		private System.Windows.Forms.Label label1;
		private System.Windows.Forms.GroupBox groupBox2;
		private System.Windows.Forms.Label label7;
		private System.Windows.Forms.Label label8;
		private System.Windows.Forms.Button Write_DO;
		private System.Windows.Forms.GroupBox groupBox1;
		private System.Windows.Forms.Label label9;
		private System.Windows.Forms.Label label10;
		private System.Windows.Forms.Button Read_DO;
		private System.Windows.Forms.GroupBox groupBox3;
		private System.Windows.Forms.Button Open_Com;
		private System.Windows.Forms.Button Close_Com;
		private System.Windows.Forms.TextBox textWrCh;
		private System.Windows.Forms.TextBox textWV;
		private System.Windows.Forms.TextBox textRdCh;
		private System.Windows.Forms.TextBox textRV;
		/// <summary>
		/// 設計工具所需的變數。
		/// </summary>
		private System.ComponentModel.Container components = null;

		public form1()
		{
			//
			// Windows Form 設計工具支援的必要項
			//
			InitializeComponent();

			//
			// TODO: 在 InitializeComponent 呼叫之後加入任何建構函式程式碼
			//
		}

		/// <summary>
		/// 清除任何使用中的資源。
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form 設計工具產生的程式碼
		/// <summary>
		/// 此為設計工具支援所必須的方法 - 請勿使用程式碼編輯器修改
		/// 這個方法的內容。
		/// </summary>
		private void InitializeComponent()
		{
			this.textAddress = new System.Windows.Forms.TextBox();
			this.label11 = new System.Windows.Forms.Label();
			this.textTotalChannel = new System.Windows.Forms.TextBox();
			this.label6 = new System.Windows.Forms.Label();
			this.textTimeout = new System.Windows.Forms.TextBox();
			this.textChecksum = new System.Windows.Forms.TextBox();
			this.textSlot = new System.Windows.Forms.TextBox();
			this.textBaudrate = new System.Windows.Forms.TextBox();
			this.textComport = new System.Windows.Forms.TextBox();
			this.label5 = new System.Windows.Forms.Label();
			this.label4 = new System.Windows.Forms.Label();
			this.label3 = new System.Windows.Forms.Label();
			this.label2 = new System.Windows.Forms.Label();
			this.label1 = new System.Windows.Forms.Label();
			this.groupBox2 = new System.Windows.Forms.GroupBox();
			this.textWrCh = new System.Windows.Forms.TextBox();
			this.label7 = new System.Windows.Forms.Label();
			this.textWV = new System.Windows.Forms.TextBox();
			this.label8 = new System.Windows.Forms.Label();
			this.Write_DO = new System.Windows.Forms.Button();
			this.groupBox1 = new System.Windows.Forms.GroupBox();
			this.textRdCh = new System.Windows.Forms.TextBox();
			this.textRV = new System.Windows.Forms.TextBox();
			this.label9 = new System.Windows.Forms.Label();
			this.label10 = new System.Windows.Forms.Label();
			this.Read_DO = new System.Windows.Forms.Button();
			this.groupBox3 = new System.Windows.Forms.GroupBox();
			this.Open_Com = new System.Windows.Forms.Button();
			this.Close_Com = new System.Windows.Forms.Button();
			this.SuspendLayout();
			// 
			// textAddress
			// 
			this.textAddress.Location = new System.Drawing.Point(72, 64);
			this.textAddress.Name = "textAddress";
			this.textAddress.Size = new System.Drawing.Size(72, 22);
			this.textAddress.TabIndex = 63;
			this.textAddress.Text = "1";
			// 
			// label11
			// 
			this.label11.Location = new System.Drawing.Point(24, 64);
			this.label11.Name = "label11";
			this.label11.Size = new System.Drawing.Size(48, 16);
			this.label11.TabIndex = 62;
			this.label11.Text = "Address";
			// 
			// textTotalChannel
			// 
			this.textTotalChannel.Location = new System.Drawing.Point(72, 232);
			this.textTotalChannel.Name = "textTotalChannel";
			this.textTotalChannel.Size = new System.Drawing.Size(72, 22);
			this.textTotalChannel.TabIndex = 61;
			this.textTotalChannel.Text = "8";
			// 
			// label6
			// 
			this.label6.Location = new System.Drawing.Point(16, 232);
			this.label6.Name = "label6";
			this.label6.Size = new System.Drawing.Size(48, 24);
			this.label6.TabIndex = 60;
			this.label6.Text = "Total Channel";
			// 
			// textTimeout
			// 
			this.textTimeout.Location = new System.Drawing.Point(72, 200);
			this.textTimeout.Name = "textTimeout";
			this.textTimeout.Size = new System.Drawing.Size(72, 22);
			this.textTimeout.TabIndex = 59;
			this.textTimeout.Text = "100";
			// 
			// textChecksum
			// 
			this.textChecksum.Location = new System.Drawing.Point(72, 168);
			this.textChecksum.Name = "textChecksum";
			this.textChecksum.Size = new System.Drawing.Size(72, 22);
			this.textChecksum.TabIndex = 58;
			this.textChecksum.Text = "0";
			// 
			// textSlot
			// 
			this.textSlot.Location = new System.Drawing.Point(72, 136);
			this.textSlot.Name = "textSlot";
			this.textSlot.Size = new System.Drawing.Size(72, 22);
			this.textSlot.TabIndex = 57;
			this.textSlot.Text = "-1";
			// 
			// textBaudrate
			// 
			this.textBaudrate.Location = new System.Drawing.Point(72, 96);
			this.textBaudrate.Name = "textBaudrate";
			this.textBaudrate.Size = new System.Drawing.Size(72, 22);
			this.textBaudrate.TabIndex = 56;
			this.textBaudrate.Text = "9600";
			// 
			// textComport
			// 
			this.textComport.Location = new System.Drawing.Point(72, 32);
			this.textComport.Name = "textComport";
			this.textComport.Size = new System.Drawing.Size(72, 22);
			this.textComport.TabIndex = 55;
			this.textComport.Text = "1";
			// 
			// label5
			// 
			this.label5.Location = new System.Drawing.Point(16, 208);
			this.label5.Name = "label5";
			this.label5.Size = new System.Drawing.Size(48, 16);
			this.label5.TabIndex = 54;
			this.label5.Text = "Timeout";
			// 
			// label4
			// 
			this.label4.Location = new System.Drawing.Point(16, 176);
			this.label4.Name = "label4";
			this.label4.Size = new System.Drawing.Size(56, 16);
			this.label4.TabIndex = 53;
			this.label4.Text = "CheckSum";
			// 
			// label3
			// 
			this.label3.Location = new System.Drawing.Point(24, 144);
			this.label3.Name = "label3";
			this.label3.Size = new System.Drawing.Size(24, 16);
			this.label3.TabIndex = 52;
			this.label3.Text = "Slot";
			// 
			// label2
			// 
			this.label2.Location = new System.Drawing.Point(16, 104);
			this.label2.Name = "label2";
			this.label2.Size = new System.Drawing.Size(64, 16);
			this.label2.TabIndex = 51;
			this.label2.Text = "Baudrate";
			// 
			// label1
			// 
			this.label1.Location = new System.Drawing.Point(16, 32);
			this.label1.Name = "label1";
			this.label1.Size = new System.Drawing.Size(48, 16);
			this.label1.TabIndex = 50;
			this.label1.Text = "ComPort";
			// 
			// groupBox2
			// 
			this.groupBox2.Location = new System.Drawing.Point(8, 8);
			this.groupBox2.Name = "groupBox2";
			this.groupBox2.Size = new System.Drawing.Size(152, 264);
			this.groupBox2.TabIndex = 64;
			this.groupBox2.TabStop = false;
			this.groupBox2.Text = "Setting";
			// 
			// textWrCh
			// 
			this.textWrCh.Location = new System.Drawing.Point(240, 24);
			this.textWrCh.Name = "textWrCh";
			this.textWrCh.Size = new System.Drawing.Size(64, 22);
			this.textWrCh.TabIndex = 65;
			this.textWrCh.Text = "";
			// 
			// label7
			// 
			this.label7.Location = new System.Drawing.Point(184, 24);
			this.label7.Name = "label7";
			this.label7.Size = new System.Drawing.Size(48, 24);
			this.label7.TabIndex = 66;
			this.label7.Text = "Channel Number";
			// 
			// textWV
			// 
			this.textWV.Location = new System.Drawing.Point(240, 64);
			this.textWV.Name = "textWV";
			this.textWV.Size = new System.Drawing.Size(64, 22);
			this.textWV.TabIndex = 67;
			this.textWV.Text = "";
			// 
			// label8
			// 
			this.label8.Location = new System.Drawing.Point(192, 64);
			this.label8.Name = "label8";
			this.label8.Size = new System.Drawing.Size(32, 24);
			this.label8.TabIndex = 68;
			this.label8.Text = "Write Value";
			// 
			// Write_DO
			// 
			this.Write_DO.Location = new System.Drawing.Point(184, 96);
			this.Write_DO.Name = "Write_DO";
			this.Write_DO.Size = new System.Drawing.Size(128, 32);
			this.Write_DO.TabIndex = 69;
			this.Write_DO.Text = "Writ DO";
			this.Write_DO.Click += new System.EventHandler(this.Write_DO_Click);
			// 
			// groupBox1
			// 
			this.groupBox1.Location = new System.Drawing.Point(168, 8);
			this.groupBox1.Name = "groupBox1";
			this.groupBox1.Size = new System.Drawing.Size(152, 136);
			this.groupBox1.TabIndex = 70;
			this.groupBox1.TabStop = false;
			this.groupBox1.Text = "Write DO";
			// 
			// textRdCh
			// 
			this.textRdCh.Location = new System.Drawing.Point(248, 160);
			this.textRdCh.Name = "textRdCh";
			this.textRdCh.Size = new System.Drawing.Size(64, 22);
			this.textRdCh.TabIndex = 71;
			this.textRdCh.Text = "";
			// 
			// textRV
			// 
			this.textRV.Location = new System.Drawing.Point(248, 192);
			this.textRV.Name = "textRV";
			this.textRV.Size = new System.Drawing.Size(64, 22);
			this.textRV.TabIndex = 72;
			this.textRV.Text = "";
			// 
			// label9
			// 
			this.label9.Location = new System.Drawing.Point(192, 160);
			this.label9.Name = "label9";
			this.label9.Size = new System.Drawing.Size(48, 24);
			this.label9.TabIndex = 73;
			this.label9.Text = "Channel Number";
			// 
			// label10
			// 
			this.label10.Location = new System.Drawing.Point(200, 192);
			this.label10.Name = "label10";
			this.label10.Size = new System.Drawing.Size(32, 24);
			this.label10.TabIndex = 74;
			this.label10.Text = "Read Value";
			// 
			// Read_DO
			// 
			this.Read_DO.Location = new System.Drawing.Point(184, 224);
			this.Read_DO.Name = "Read_DO";
			this.Read_DO.Size = new System.Drawing.Size(128, 32);
			this.Read_DO.TabIndex = 75;
			this.Read_DO.Text = "Read DO";
			this.Read_DO.Click += new System.EventHandler(this.Read_DO_Click);
			// 
			// groupBox3
			// 
			this.groupBox3.Location = new System.Drawing.Point(168, 144);
			this.groupBox3.Name = "groupBox3";
			this.groupBox3.Size = new System.Drawing.Size(152, 128);
			this.groupBox3.TabIndex = 76;
			this.groupBox3.TabStop = false;
			this.groupBox3.Text = "Read DO";
			// 
			// Open_Com
			// 
			this.Open_Com.Location = new System.Drawing.Point(72, 288);
			this.Open_Com.Name = "Open_Com";
			this.Open_Com.Size = new System.Drawing.Size(72, 32);
			this.Open_Com.TabIndex = 77;
			this.Open_Com.Text = "Open Com";
			this.Open_Com.Click += new System.EventHandler(this.Open_Com_Click);
			// 
			// Close_Com
			// 
			this.Close_Com.Location = new System.Drawing.Point(184, 288);
			this.Close_Com.Name = "Close_Com";
			this.Close_Com.Size = new System.Drawing.Size(72, 32);
			this.Close_Com.TabIndex = 78;
			this.Close_Com.Text = "Close Com";
			this.Close_Com.Click += new System.EventHandler(this.Close_Com_Click);
			// 
			// form1
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 15);
			this.ClientSize = new System.Drawing.Size(328, 325);
			this.Controls.Add(this.Close_Com);
			this.Controls.Add(this.Open_Com);
			this.Controls.Add(this.Read_DO);
			this.Controls.Add(this.label10);
			this.Controls.Add(this.label9);
			this.Controls.Add(this.textRV);
			this.Controls.Add(this.textRdCh);
			this.Controls.Add(this.Write_DO);
			this.Controls.Add(this.label8);
			this.Controls.Add(this.textWV);
			this.Controls.Add(this.label7);
			this.Controls.Add(this.textWrCh);
			this.Controls.Add(this.textAddress);
			this.Controls.Add(this.label11);
			this.Controls.Add(this.textTotalChannel);
			this.Controls.Add(this.label6);
			this.Controls.Add(this.textTimeout);
			this.Controls.Add(this.textChecksum);
			this.Controls.Add(this.textSlot);
			this.Controls.Add(this.textBaudrate);
			this.Controls.Add(this.textComport);
			this.Controls.Add(this.label5);
			this.Controls.Add(this.label4);
			this.Controls.Add(this.label3);
			this.Controls.Add(this.label2);
			this.Controls.Add(this.label1);
			this.Controls.Add(this.groupBox2);
			this.Controls.Add(this.groupBox1);
			this.Controls.Add(this.groupBox3);
			this.Name = "form1";
			this.Text = "Form1";
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// 應用程式的主進入點。
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new form1());
		}
		
		short iSlot,iTimeout,iTotalChannel,iAddress,bChecksum;
		byte iComport;
		uint iBaudrate;
		private void Write_DO_Click(object sender, System.EventArgs e)
		{
			short iRet;
			iRet=DCON.IO_Function.Write_AO(iComport,iAddress,iSlot,Convert.ToInt16(textWrCh.Text),iTotalChannel,Convert.ToSingle(textWV.Text),bChecksum,iTimeout);
			
			if(Convert.ToBoolean( iRet))
				MessageBox.Show("ErrorCode " + Convert.ToString(iRet));
		
		}

		private void Read_DO_Click(object sender, System.EventArgs e)
		{
			float AOValue;
			short iRet;
			iRet=DCON.IO_Function.Read_AO(iComport,iAddress,iSlot,Convert.ToInt16(textRdCh.Text),iTotalChannel,bChecksum,iTimeout,out AOValue);
			
			if(Convert.ToBoolean( iRet))
				MessageBox.Show("ErrorCode " + Convert.ToString(iRet));
			else
				textRV.Text=Convert.ToString(AOValue);
		}

		private void Open_Com_Click(object sender, System.EventArgs e)
		{
			iComport=Convert.ToByte(textComport.Text);
			iAddress = Convert.ToInt16(textAddress.Text);
			iBaudrate=Convert.ToUInt32(textBaudrate.Text);
			iSlot=Convert.ToInt16(textSlot.Text);
			bChecksum=Convert.ToInt16(textChecksum.Text);
			iTimeout=Convert.ToInt16(textTimeout.Text);
			iTotalChannel=Convert.ToInt16(textTotalChannel.Text);

			DCON.UART.Open_Com(iComport,iBaudrate,8,0,1);
		}

		private void Close_Com_Click(object sender, System.EventArgs e)
		{
			DCON.UART.Close_Com(iComport);
		}

	}
}
